scala.collection.JavaConversions

# JIterableWrapper

#### case class JIterableWrapper[A](underlying: Iterable[A]) extends Iterable[A] with Product with Serializable

Source
  JavaConversions.scala

Linear Supertypes
Serializable, Serializable, Product, Iterable[A], IterableLike[A, Iterable[A]], Equals, GenIterable[A], GenIterableLike[A, Iterable[A]], Traversable[A], GenTraversable[A], GenericTraversableTemplate[A, Iterable], TraversableLike[A, Iterable[A]], GenTraversableLike[A, Iterable[A]], Parallelizable[A, ParIterable[A]], TraversableOnce[A], GenTraversableOnce[A], FilterMonadic[A, Iterable[A]], HasNewBuilder[A, Iterable[A]], AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. JIterableWrapper
2. Serializable
3. Serializable
4. Product
5. Iterable
6. IterableLike
7. Equals
8. GenIterable
9. GenIterableLike
10. Traversable
11. GenTraversable
12. GenericTraversableTemplate
13. TraversableLike
14. GenTraversableLike
15. Parallelizable
16. TraversableOnce
17. GenTraversableOnce
18. FilterMonadic
19. HasNewBuilder
20. AnyRef
21. Any

Visibility

1. Public
2. All

### Instance Constructors

1. #### new JIterableWrapper(underlying: Iterable[A])

### Type Members

1. #### type Self = Iterable[A]

   The type implementing this traversable

   The type implementing this traversable

   Attributes
     protected
   Definition Classes
     TraversableLike

2. #### class WithFilter extends FilterMonadic[A, Repr]

   A class supporting filtered operations.

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### abstract def ++[B](that: GenTraversableOnce[B]): Iterable[B]

   [use case] Returns a new iterable collection containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new iterable collection containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the iterable collection is the most specific superclass encompassing the element types of the two operands (see example).

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this iterable collection followed by all elements of `that`.

   Definition Classes
     GenTraversableLike

5. #### def ++[B >: A, That](that: GenTraversableOnce[B])(implicit bf: CanBuildFrom[Iterable[A], B, That]): That

   Returns a new iterable collection containing the elements from the left hand operand followed by the elements from the right hand operand.

   Returns a new iterable collection containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the iterable collection is the most specific superclass encompassing the element types of the two operands (see example).

   Example:

           scala> val a = LinkedList(1)
           a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

           scala> val b = LinkedList(2)
           b: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val c = a ++ b
           c: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

           scala> val d = LinkedList('a')
           d: scala.collection.mutable.LinkedList[Char] = LinkedList(a)

           scala> val e = c ++ d
           e: scala.collection.mutable.LinkedList[AnyVal] = LinkedList(1, 2, a)

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this iterable collection followed by all elements of `that`.

   Definition Classes
     TraversableLike → GenTraversableLike

6. #### def ++:[B >: A, That](that: Traversable[B])(implicit bf: CanBuildFrom[Iterable[A], B, That]): That

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand. It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one.

   Example:

           scala> val x = List(1)
           x: List[Int] = List(1)

           scala> val y = LinkedList(2)
           y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val z = x ++: y
           z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   This overload exists because: for the implementation of `++:` we should reuse that of `++` because many collections override it with more efficient versions.

   Since `TraversableOnce` has no `++` method, we have to implement that directly, but `Traversable` and down can use the overload.

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

   returns

     a new iterable collection which contains all elements of this iterable collection followed by all elements of `that`.

   Definition Classes
     TraversableLike

7. #### abstract def ++:[B](that: TraversableOnce[B]): Iterable[B]

   [use case] Concatenates this iterable collection with the elements of a traversable collection.

   [use case]

   Concatenates this iterable collection with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this iterable collection followed by all elements of `that`.

   Definition Classes
     TraversableLike

8. #### def ++:[B >: A, That](that: TraversableOnce[B])(implicit bf: CanBuildFrom[Iterable[A], B, That]): That

   Concatenates this iterable collection with the elements of a traversable collection.

   Concatenates this iterable collection with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

   Example:

           scala> val x = List(1)
           x: List[Int] = List(1)

           scala> val y = LinkedList(2)
           y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val z = x ++: y
           z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this iterable collection followed by all elements of `that`.

   Definition Classes
     TraversableLike

9. #### def /:[B](z: B)(op: (B, A) ⇒ B): B

   Applies a binary operator to a start value and all elements of this iterable collection, going left to right.

   Applies a binary operator to a start value and all elements of this iterable collection, going left to right.

   Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

            scala> val a = LinkedList(1,2,3,4)
            a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

            scala> val b = (5 /: a)(_+_)
            b: Int = 15

            scala> val c = (5 /: a)((x,y) => x + y)
            c: Int = 15

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

   B

     the result type of the binary operator.

   z

     the start value.

   op

     the binary operator.

   returns

     the result of inserting `op` between consecutive elements of this iterable collection, going left to right with the start value `z` on the left:

                     op(...op(op(z, x1), x2), ..., xn)

     where `x1, ..., xn` are the elements of this iterable collection.

   Definition Classes
     TraversableOnce → GenTraversableOnce

10. #### def /:\[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

    A syntactic sugar for out of order folding.

    A syntactic sugar for out of order folding. See `fold`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a /:\ 5)(_+_)
             b: Int = 15

    Definition Classes
      GenTraversableOnce

11. #### def :\[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this iterable collection and a start value, going right to left.

    Applies a binary operator to all elements of this iterable collection and a start value, going right to left.

    Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a :\ 5)(_+_)
             b: Int = 15

             scala> val c = (a :\ 5)((x,y) => x + y)
             c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value

    op

      the binary operator

    returns

      the result of inserting `op` between consecutive elements of this iterable collection, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this iterable collection.

    Definition Classes
      TraversableOnce → GenTraversableOnce

12. #### final def ==(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

13. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

14. #### def addString(b: StringBuilder): StringBuilder

    Appends all elements of this iterable collection to a string builder.

    Appends all elements of this iterable collection to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this iterable collection without any separator string.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> val h = a.addString(b)
             b: StringBuilder = 1234

    b

      the string builder to which elements are appended.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

15. #### def addString(b: StringBuilder, sep: String): StringBuilder

    Appends all elements of this iterable collection to a string builder using a separator string.

    Appends all elements of this iterable collection to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this iterable collection, separated by the string `sep`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> a.addString(b, ", ")
             res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

16. #### def addString(b: StringBuilder, start: String, sep: String, end: String): StringBuilder

    Appends all elements of this iterable collection to a string builder using start, end, and separator strings.

    Appends all elements of this iterable collection to a string builder using start, end, and separator strings. The written text begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this iterable collection are separated by the string `sep`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> a.addString(b, "LinkedList(", ", ", ")")
             res1: StringBuilder = LinkedList(1, 2, 3, 4)

    b

      the string builder to which elements are appended.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

17. #### def aggregate[B](z: B)(seqop: (B, A) ⇒ B, combop: (B, B) ⇒ B): B

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

           pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    B

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      TraversableOnce → GenTraversableOnce

18. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

19. #### def canEqual(that: Any): Boolean

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    that

      The object with which this iterable collection should be compared

    returns

      `true`, if this iterable collection can possibly equal `that`, `false` otherwise. The test takes into consideration only the run-time types of objects but ignores their elements.

    Definition Classes
      IterableLike → Equals

20. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

21. #### abstract def collect[B](pf: PartialFunction[A, B]): Iterable[B]

    [use case] Builds a new collection by applying a partial function to all elements of this iterable collection on which the function is defined.

    [use case]

    Builds a new collection by applying a partial function to all elements of this iterable collection on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the iterable collection.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      GenTraversableLike

22. #### def collect[B, That](pf: PartialFunction[A, B])(implicit bf: CanBuildFrom[Iterable[A], B, That]): That

    Builds a new collection by applying a partial function to all elements of this iterable collection on which the function is defined.

    Builds a new collection by applying a partial function to all elements of this iterable collection on which the function is defined.

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    pf

      the partial function which filters and maps the iterable collection.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

23. #### def collectFirst[B](pf: PartialFunction[A, B]): Option[B]

    Finds the first element of the iterable collection for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the iterable collection for which the given partial function is defined, and applies the partial function to it.

    Note: may not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Definition Classes
      TraversableOnce
    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

24. #### def companion: GenericCompanion[Iterable]

    The factory companion object that builds instances of class Iterable.

    The factory companion object that builds instances of class Iterable. (or its `Iterable` superclass where class Iterable is not a `Seq`.)

    Definition Classes
      Iterable → GenIterable → Traversable → GenTraversable → GenericTraversableTemplate

25. #### abstract def copyToArray(xs: Array[A], start: Int, len: Int): Unit

    [use case] Copies elements of this iterable collection to an array.

    [use case]

    Copies elements of this iterable collection to an array. Fills the given array `xs` with at most `len` elements of this iterable collection, starting at position `start`. Copying will stop once either the end of the current iterable collection is reached, or the end of the array is reached, or `len` elements have been copied.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      TraversableLike

26. #### def copyToArray[B >: A](xs: Array[B], start: Int, len: Int): Unit

    Copies elements of this iterable collection to an array.

    Copies elements of this iterable collection to an array. Fills the given array `xs` with at most `len` elements of this iterable collection, starting at position `start`. Copying will stop once either the end of the current iterable collection is reached, or the end of the array is reached, or `len` elements have been copied.

    Note: will not terminate for infinite-sized collections.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

27. #### abstract def copyToArray(xs: Array[A]): Unit

    [use case] Copies values of this iterable collection to an array.

    [use case]

    Copies values of this iterable collection to an array. Fills the given array `xs` with values of this iterable collection. Copying will stop once either the end of the current iterable collection is reached, or the end of the array is reached.

    xs

      the array to fill.

    Definition Classes
      GenTraversableOnce

28. #### def copyToArray[B >: A](xs: Array[B]): Unit

    Copies values of this iterable collection to an array.

    Copies values of this iterable collection to an array. Fills the given array `xs` with values of this iterable collection. Copying will stop once either the end of the current iterable collection is reached, or the end of the array is reached.

    Note: will not terminate for infinite-sized collections.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    Definition Classes
      TraversableOnce → GenTraversableOnce

29. #### abstract def copyToArray(xs: Array[A], start: Int): Unit

    [use case] Copies values of this iterable collection to an array.

    [use case]

    Copies values of this iterable collection to an array. Fills the given array `xs` with values of this iterable collection, beginning at index `start`. Copying will stop once either the end of the current iterable collection is reached, or the end of the array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      GenTraversableOnce

30. #### def copyToArray[B >: A](xs: Array[B], start: Int): Unit

    Copies values of this iterable collection to an array.

    Copies values of this iterable collection to an array. Fills the given array `xs` with values of this iterable collection, beginning at index `start`. Copying will stop once either the end of the current iterable collection is reached, or the end of the array is reached.

    Note: will not terminate for infinite-sized collections.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      TraversableOnce → GenTraversableOnce

31. #### def copyToBuffer[B >: A](dest: Buffer[B]): Unit

    Copies all elements of this iterable collection to a buffer.

    Copies all elements of this iterable collection to a buffer.

    Note: will not terminate for infinite-sized collections.

    dest

      The buffer to which elements are copied.

    Definition Classes
      TraversableOnce

32. #### def count(p: (A) ⇒ Boolean): Int

    Counts the number of elements in the iterable collection which satisfy a predicate.

    Counts the number of elements in the iterable collection which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

33. #### def drop(n: Int): Iterable[A]

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      the number of elements to drop from this iterable collection.

    returns

      a iterable collection consisting of all elements of this iterable collection except the first `n` ones, or else the empty iterable collection, if this iterable collection has less than `n` elements.

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike

34. #### def dropRight(n: Int): Iterable[A]

    Selects all elements except last n ones.

    Selects all elements except last n ones.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      The number of elements to take

    returns

      a iterable collection consisting of all elements of this iterable collection except the last `n` ones, or else the empty iterable collection, if this iterable collection has less than `n` elements.

    Definition Classes
      IterableLike

35. #### def dropWhile(p: (A) ⇒ Boolean): Iterable[A]

    Drops longest prefix of elements that satisfy a predicate.

    Drops longest prefix of elements that satisfy a predicate.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    p

      The predicate used to test elements.

    returns

      the longest suffix of this iterable collection whose first element does not satisfy the predicate `p`.

    Definition Classes
      TraversableLike → GenTraversableLike

36. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

37. #### def equals(arg0: Any): Boolean

    The universal equality method defined in `AnyRef`.

    The universal equality method defined in `AnyRef`.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      JIterableWrapper → Equals → AnyRef → Any

38. #### def exists(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some of the elements of this iterable collection.

    Tests whether a predicate holds for some of the elements of this iterable collection.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for some of the elements of this iterable collection, otherwise `false`.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

39. #### def filter(p: (A) ⇒ Boolean): Iterable[A]

    Selects all elements of this iterable collection which satisfy a predicate.

    Selects all elements of this iterable collection which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new iterable collection consisting of all elements of this iterable collection that satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

40. #### def filterNot(p: (A) ⇒ Boolean): Iterable[A]

    Selects all elements of this iterable collection which do not satisfy a predicate.

    Selects all elements of this iterable collection which do not satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new iterable collection consisting of all elements of this iterable collection that do not satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

41. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

42. #### def find(p: (A) ⇒ Boolean): Option[A]

    Finds the first element of the iterable collection satisfying a predicate, if any.

    Finds the first element of the iterable collection satisfying a predicate, if any.

    Note: may not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    p

      the predicate used to test elements.

    returns

      an option value containing the first element in the iterable collection that satisfies `p`, or `None` if none exists.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

43. #### abstract def flatMap[B](f: (A) ⇒ GenTraversableOnce[B]): Iterable[B]

    [use case] Builds a new collection by applying a function to all elements of this iterable collection and using the elements of the resulting collections.

    [use case]

    Builds a new collection by applying a function to all elements of this iterable collection and using the elements of the resulting collections. For example:

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this iterable collection and concatenating the results.

    Definition Classes
      GenTraversableLike

44. #### def flatMap[B, That](f: (A) ⇒ GenTraversableOnce[B])(implicit bf: CanBuildFrom[Iterable[A], B, That]): That

    Builds a new collection by applying a function to all elements of this iterable collection and using the elements of the resulting collections.

    Builds a new collection by applying a function to all elements of this iterable collection and using the elements of the resulting collections. For example:

         def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of iterable collection. This might cause unexpected results sometimes. For example:

         // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
         def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

         // lettersOf will return a Set[Char], not a Seq
         def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

         // xs will be a an Iterable[Int]
         val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

         // ys will be a Map[Int, Int]
         val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this iterable collection and concatenating the results.

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic

45. #### abstract def flatten[B]: Iterable[B]

    [use case] Converts this iterable collection of traversable collections into a iterable collection formed by the elements of these traversable collections.

    [use case]

    Converts this iterable collection of traversable collections into a iterable collection formed by the elements of these traversable collections.

    B

      the type of the elements of each traversable collection.

    returns

      a new iterable collection resulting from concatenating all element iterable collections.

    Definition Classes
      GenericTraversableTemplate

46. #### def fold[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this iterable collection using the specified associative binary operator.

    Folds the elements of this iterable collection using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      TraversableOnce → GenTraversableOnce

47. #### def foldLeft[B](z: B)(op: (B, A) ⇒ B): B

    Applies a binary operator to a start value and all elements of this iterable collection, going left to right.

    Applies a binary operator to a start value and all elements of this iterable collection, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this iterable collection, going left to right with the start value `z` on the left:

                      op(...op(z, x1), x2, ..., xn)

      where `x1, ..., xn` are the elements of this iterable collection.

    Definition Classes
      TraversableOnce → GenTraversableOnce

48. #### def foldRight[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this iterable collection and a start value, going right to left.

    Applies a binary operator to all elements of this iterable collection and a start value, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this iterable collection, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this iterable collection.

    Definition Classes
      IterableLike → TraversableOnce → GenTraversableOnce

49. #### def forall(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this iterable collection.

    Tests whether a predicate holds for all elements of this iterable collection.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for all elements of this iterable collection, otherwise `false`.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

50. #### abstract def foreach(f: (A) ⇒ Unit): Unit

    [use case] Applies a function `f` to all elements of this iterable collection.

    [use case]

    Applies a function `f` to all elements of this iterable collection.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      IterableLike

51. #### def foreach[U](f: (A) ⇒ U): Unit

    Applies a function `f` to all elements of this iterable collection.

    Applies a function `f` to all elements of this iterable collection.

    Note: this method underlies the implementation of most other bulk operations. Subclasses should re-implement this method if a more efficient implementation exists.

    U

      the type parameter describing the result of function `f`. This result will always be ignored. Typically `U` is `Unit`, but this is not necessary.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike → TraversableOnce → GenTraversableOnce → FilterMonadic

52. #### def genericBuilder[B]: Builder[B, Iterable[B]]

    The generic builder that builds instances of Iterable at arbitrary element types.

    The generic builder that builds instances of Iterable at arbitrary element types.

    Definition Classes
      GenericTraversableTemplate

53. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

54. #### def groupBy[K](f: (A) ⇒ K): Map[K, Iterable[A]]

    Partitions this iterable collection into a map of iterable collections according to some discriminator function.

    Partitions this iterable collection into a map of iterable collections according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new iterable collection.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to iterable collections such that the following invariant holds:

                          (xs partition f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a iterable collection of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      TraversableLike → GenTraversableLike

55. #### def grouped(size: Int): Iterator[Iterable[A]]

    Partitions elements in fixed size iterable collections.

    Partitions elements in fixed size iterable collections.

    size

      the number of elements per group

    returns

      An iterator producing iterable collections of size `size`, except the last will be truncated if the elements don't divide evenly.

    Definition Classes
      IterableLike
    See also

      Iterator#grouped

56. #### def hasDefiniteSize: Boolean

    Tests whether this iterable collection is known to have a finite size.

    Tests whether this iterable collection is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end.

    Note: many collection methods will not work on collections of infinite sizes.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

57. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      JIterableWrapper → AnyRef → Any

58. #### def head: A

    Selects the first element of this iterable collection.

    Selects the first element of this iterable collection.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this iterable collection.

    Definition Classes
      IterableLike → GenIterableLike → TraversableLike → GenTraversableLike
    Exceptions thrown
      `NoSuchElementException`

      if the iterable collection is empty.

59. #### def headOption: Option[A]

    Optionally selects the first element.

    Optionally selects the first element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this iterable collection if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike

60. #### def init: Iterable[A]

    Selects all elements except the last.

    Selects all elements except the last.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      a iterable collection consisting of all elements of this iterable collection except the last one.

    Definition Classes
      TraversableLike
    Exceptions thrown
      `UnsupportedOperationException`

      if the iterable collection is empty.

61. #### def inits: Iterator[Iterable[A]]

    Iterates over the inits of this iterable collection.

    Iterates over the inits of this iterable collection. The first value will be this iterable collection and the final one will be an empty iterable collection, with the intervening values the results of successive applications of `init`.

    returns

      an iterator over all the inits of this iterable collection

    Definition Classes
      TraversableLike
    Example:

    1. `List(1,2,3).inits = Iterator(List(1,2,3), List(1,2), List(1), Nil)`

62. #### def isEmpty: Boolean

    Tests whether the iterable collection is empty.

    Tests whether the iterable collection is empty.

    returns

      `true` if the iterable collection contains no elements, `false` otherwise.

    Definition Classes
      IterableLike → GenIterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

63. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

64. #### final def isTraversableAgain: Boolean

    Tests whether this iterable collection can be repeatedly traversed.

    Tests whether this iterable collection can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      GenTraversableLike → GenTraversableOnce

65. #### def iterator: Iterator[A]

    Creates a new iterator over all elements contained in this iterable object.

    Creates a new iterator over all elements contained in this iterable object.

    returns

      the new iterator

    Definition Classes
      JIterableWrapper → IterableLike → GenIterableLike

66. #### def last: A

    Selects the last element.

    Selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      The last element of this iterable collection.

    Definition Classes
      TraversableLike
    Exceptions thrown
      NoSuchElementException

      If the iterable collection is empty.

67. #### def lastOption: Option[A]

    Optionally selects the last element.

    Optionally selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the last element of this iterable collection$ if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike

68. #### abstract def map[B](f: (A) ⇒ B): Iterable[B]

    [use case] Builds a new collection by applying a function to all elements of this iterable collection.

    [use case]

    Builds a new collection by applying a function to all elements of this iterable collection.

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given function `f` to each element of this iterable collection and collecting the results.

    Definition Classes
      GenTraversableLike

69. #### def map[B, That](f: (A) ⇒ B)(implicit bf: CanBuildFrom[Iterable[A], B, That]): That

    Builds a new collection by applying a function to all elements of this iterable collection.

    Builds a new collection by applying a function to all elements of this iterable collection.

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given function `f` to each element of this iterable collection and collecting the results.

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic

70. #### abstract def max: A

    [use case] Finds the largest element.

    [use case]

    Finds the largest element.

    returns

      the largest element of this iterable collection with respect to the ordering `cmp`.

    Definition Classes
      GenTraversableOnce

71. #### def max[B >: A](implicit cmp: Ordering[B]): A

    Finds the largest element.

    Finds the largest element.

    B

      The type over which the ordering is defined.

    cmp

      An ordering to be used for comparing elements.

    returns

      the largest element of this iterable collection with respect to the ordering `cmp`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

72. #### def maxBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

    Definition Classes
      TraversableOnce → GenTraversableOnce

73. #### abstract def min: A

    [use case] Finds the smallest element.

    [use case]

    Finds the smallest element.

    returns

      the smallest element of this iterable collection with respect to the ordering `cmp`.

    Definition Classes
      GenTraversableOnce

74. #### def min[B >: A](implicit cmp: Ordering[B]): A

    Finds the smallest element.

    Finds the smallest element.

    B

      The type over which the ordering is defined.

    cmp

      An ordering to be used for comparing elements.

    returns

      the smallest element of this iterable collection with respect to the ordering `cmp`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

75. #### def minBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

    Definition Classes
      TraversableOnce → GenTraversableOnce

76. #### def mkString: String

    Displays all elements of this iterable collection in a string.

    Displays all elements of this iterable collection in a string.

    returns

      a string representation of this iterable collection. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this iterable collection follow each other without any separator string.

    Definition Classes
      TraversableOnce → GenTraversableOnce

77. #### def mkString(sep: String): String

    Displays all elements of this iterable collection in a string using a separator string.

    Displays all elements of this iterable collection in a string using a separator string.

    sep

      the separator string.

    returns

      a string representation of this iterable collection. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this iterable collection are separated by the string `sep`.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("|") = "1|2|3"`

78. #### def mkString(start: String, sep: String, end: String): String

    Displays all elements of this iterable collection in a string using start, end, and separator strings.

    Displays all elements of this iterable collection in a string using start, end, and separator strings.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      a string representation of this iterable collection. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this iterable collection are separated by the string `sep`.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

79. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

80. #### def newBuilder[B]: ArrayBuffer[B]

81. #### def newBuilder: Builder[A, Iterable[A]]

    The builder that builds instances of type Iterable[A]

    The builder that builds instances of type Iterable[A]

    Attributes
      protected[this]
    Definition Classes
      GenericTraversableTemplate → HasNewBuilder

82. #### def nonEmpty: Boolean

    Tests whether the iterable collection is not empty.

    Tests whether the iterable collection is not empty.

    returns

      `true` if the iterable collection contains at least one element, `false` otherwise.

    Definition Classes
      TraversableOnce → GenTraversableOnce

83. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

84. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

85. #### def par: ParIterable[A]

    Returns a parallel implementation of this collection.

    Returns a parallel implementation of this collection.

    For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

    Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

    All parallel collections return a reference to themselves.

    returns

      a parallel implementation of this collection

    Definition Classes
      Parallelizable

86. #### def parCombiner: Combiner[A, ParIterable[A]]

    The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

    The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

    returns

      a combiner for the parallel collection of type `ParRepr`

    Attributes
      protected[this]
    Definition Classes
      TraversableLike → Parallelizable

87. #### def partition(p: (A) ⇒ Boolean): (Iterable[A], Iterable[A])

    Partitions this iterable collection in two iterable collections according to a predicate.

    Partitions this iterable collection in two iterable collections according to a predicate.

    p

      the predicate on which to partition.

    returns

      a pair of iterable collections: the first iterable collection consists of all elements that satisfy the predicate `p` and the second iterable collection consists of all elements that don't. The relative order of the elements in the resulting iterable collections is the same as in the original iterable collection.

    Definition Classes
      TraversableLike → GenTraversableLike

88. #### abstract def product: A

    [use case] Multiplies up the elements of this collection.

    [use case]

    Multiplies up the elements of this collection.

    returns

      the product of all elements of this iterable collection with respect to the `*` operator in `num`.

    Definition Classes
      GenTraversableOnce

89. #### def product[B >: A](implicit num: Numeric[B]): B

    Multiplies up the elements of this collection.

    Multiplies up the elements of this collection.

    B

      the result type of the `*` operator.

    num

      an implicit parameter defining a set of numeric operations which includes the `*` operator to be used in forming the product.

    returns

      the product of all elements of this iterable collection with respect to the `*` operator in `num`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

90. #### def productArity: Int

    The size of this product.

    The size of this product.

    returns

      for a product `A(x_1, ..., x_k)`, returns `k`

    Definition Classes
      JIterableWrapper → Product

91. #### def productElement(arg0: Int): Any

    The nth element of this product, 0-based.

    The nth element of this product, 0-based. In other words, for a product `A(x_1, ..., x_k)`, returns x_(n+1) where 0 < n < k.

    returns

      the element `n` elements after the first element

    Definition Classes
      JIterableWrapper → Product
    Exceptions thrown
      IndexOutOfBoundsException

92. #### def productIterator: Iterator[Any]

    An iterator over all the elements of this product.

    An iterator over all the elements of this product.

    returns

      in the default implementation, an Iterator[Any]

    Definition Classes
      Product

93. #### def productPrefix: String

    A string used in the `toString` methods of derived classes.

    A string used in the `toString` methods of derived classes. Implementations may override this method to prepend a string prefix to the result of toString methods.

    returns

      in the default implementation, the empty string

    Definition Classes
      JIterableWrapper → Product

94. #### def reduce[A1 >: A](op: (A1, A1) ⇒ A1): A1

    Reduces the elements of this iterable collection using the specified associative binary operator.

    Reduces the elements of this iterable collection using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      A type parameter for the binary operator, a supertype of `A`.

    op

      A binary operator that must be associative.

    returns

      The result of applying reduce operator `op` between all the elements if the iterable collection is nonempty.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Exceptions thrown
      UnsupportedOperationException

      if this iterable collection is empty.

95. #### def reduceLeft[B >: A](op: (B, A) ⇒ B): B

    Definition Classes
      TraversableOnce

96. #### def reduceLeftOption[B >: A](op: (B, A) ⇒ B): Option[B]

    Optionally applies a binary operator to all elements of this iterable collection, going left to right.

    Optionally applies a binary operator to all elements of this iterable collection, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceLeft(op)` is this iterable collection is nonempty, `None` otherwise.

    Definition Classes
      TraversableOnce → GenTraversableOnce

97. #### def reduceOption[A1 >: A](op: (A1, A1) ⇒ A1): Option[A1]

    Reduces the elements of this iterable collection, if any, using the specified associative binary operator.

    Reduces the elements of this iterable collection, if any, using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      A type parameter for the binary operator, a supertype of `A`.

    op

      A binary operator that must be associative.

    returns

      An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

    Definition Classes
      TraversableOnce → GenTraversableOnce

98. #### def reduceRight[B >: A](op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this iterable collection, going right to left.

    Applies a binary operator to all elements of this iterable collection, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this iterable collection, going right to left:

                      op(x,,1,,, op(x,,2,,, ..., op(x,,n-1,,, x,,n,,)...))

      where `x1, ..., xn` are the elements of this iterable collection.

    Definition Classes
      IterableLike → TraversableOnce → GenTraversableOnce
    Exceptions thrown
      `UnsupportedOperationException`

      if this iterable collection is empty.

99. #### def reduceRightOption[B >: A](op: (A, B) ⇒ B): Option[B]

    Optionally applies a binary operator to all elements of this iterable collection, going right to left.

    Optionally applies a binary operator to all elements of this iterable collection, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceRight(op)` is this iterable collection is nonempty, `None` otherwise.

    Definition Classes
      TraversableOnce → GenTraversableOnce

100. #### def repr: Iterable[A]

     The collection of type iterable collection underlying this `TraversableLike` object.

     The collection of type iterable collection underlying this `TraversableLike` object. By default this is implemented as the `TraversableLike` object itself, but this can be overridden.

     Definition Classes
       TraversableLike → GenTraversableLike

101. #### def reversed: List[A]

     Attributes
       protected[this]
     Definition Classes
       TraversableOnce

102. #### abstract def sameElements(that: GenIterable[A]): Boolean

     [use case] Checks if the other iterable collection contains the same elements in the same order as this iterable collection.

     [use case]

     Checks if the other iterable collection contains the same elements in the same order as this iterable collection.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       GenIterableLike

103. #### def sameElements[B >: A](that: GenIterable[B]): Boolean

     Checks if the other iterable collection contains the same elements in the same order as this iterable collection.

     Checks if the other iterable collection contains the same elements in the same order as this iterable collection.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     Note: will not terminate for infinite-sized collections.

     B

       the type of the elements of collection `that`.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       IterableLike → GenIterableLike

104. #### def scan[B >: A, That](z: B)(op: (B, B) ⇒ B)(implicit cbf: CanBuildFrom[Iterable[A], B, That]): That

     Computes a prefix scan of the elements of the collection.

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     B

       element type of the resulting collection

     That

       type of the resulting collection

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     cbf

       combiner factory which provides a combiner

     returns

       a new iterable collection containing the prefix scan of the elements in this iterable collection

     Definition Classes
       TraversableLike → GenTraversableLike

105. #### def scanLeft[B, That](z: B)(op: (B, A) ⇒ B)(implicit bf: CanBuildFrom[Iterable[A], B, That]): That

     Produces a collection containing cummulative results of applying the operator going left to right.

     Produces a collection containing cummulative results of applying the operator going left to right.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike

106. #### def scanRight[B, That](z: B)(op: (A, B) ⇒ B)(implicit bf: CanBuildFrom[Iterable[A], B, That]): That

     Produces a collection containing cummulative results of applying the operator going right to left.

     Produces a collection containing cummulative results of applying the operator going right to left. The head of the collection is the last cummulative result.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     Example:

            List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) The behavior of `scanRight` has changed. The previous behavior can be reproduced with scanRight.reverse.

107. #### def seq: Iterable[A]

     A version of this collection with all of the operations implemented sequentially (i.

     A version of this collection with all of the operations implemented sequentially (i.e. in a single-threaded manner).

     This method returns a reference to this collection. In parallel collections, it is redefined to return a sequential implementation of this collection. In both cases, it has O(1) complexity.

     returns

       a sequential view of the collection.

     Definition Classes
       Iterable → GenIterable → Traversable → GenTraversable → Parallelizable → TraversableOnce → GenTraversableOnce

108. #### def size: Int

     The size of this iterable collection.

     The size of this iterable collection.

     Note: will not terminate for infinite-sized collections.

     returns

       the number of elements in this iterable collection.

     Definition Classes
       TraversableOnce → GenTraversableOnce

109. #### def slice(from: Int, until: Int): Iterable[A]

     Selects an interval of elements.

     Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

            from <= indexOf(x) < until

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     from

       the lowest index to include from this iterable collection.

     until

       the highest index to EXCLUDE from this iterable collection.

     returns

       a iterable collection containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this iterable collection.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

110. #### def sliding[B >: A](size: Int, step: Int): Iterator[Iterable[A]]

     Definition Classes
       IterableLike

111. #### def sliding[B >: A](size: Int): Iterator[Iterable[A]]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     size

       the number of elements per group

     returns

       An iterator producing iterable collections of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       Iterator#sliding

112. #### def span(p: (A) ⇒ Boolean): (Iterable[A], Iterable[A])

     Splits this iterable collection into a prefix/suffix pair according to a predicate.

     Splits this iterable collection into a prefix/suffix pair according to a predicate.

     Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     p

       the test predicate

     returns

       a pair consisting of the longest prefix of this iterable collection whose elements all satisfy `p`, and the rest of this iterable collection.

     Definition Classes
       TraversableLike → GenTraversableLike

113. #### def splitAt(n: Int): (Iterable[A], Iterable[A])

     Splits this iterable collection into two at a given position.

     Splits this iterable collection into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the position at which to split.

     returns

       a pair of iterable collections consisting of the first `n` elements of this iterable collection, and the other elements.

     Definition Classes
       TraversableLike → GenTraversableLike

114. #### def stringPrefix: String

     Defines the prefix of this object's `toString` representation.

     Defines the prefix of this object's `toString` representation.

     returns

       a string representation which starts the result of `toString` applied to this iterable collection. By default the string prefix is the simple name of the collection class iterable collection.

     Definition Classes
       TraversableLike → GenTraversableLike

115. #### abstract def sum: A

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements of this iterable collection with respect to the `+` operator in `num`.

     Definition Classes
       GenTraversableOnce

116. #### def sum[B >: A](implicit num: Numeric[B]): B

     Sums up the elements of this collection.

     Sums up the elements of this collection.

     B

       the result type of the `+` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `+` operator to be used in forming the sum.

     returns

       the sum of all elements of this iterable collection with respect to the `+` operator in `num`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

117. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

118. #### def tail: Iterable[A]

     Selects all elements except the first.

     Selects all elements except the first.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       a iterable collection consisting of all elements of this iterable collection except the first one.

     Definition Classes
       TraversableLike → GenTraversableLike
     Exceptions thrown
       `UnsupportedOperationException`

       if the iterable collection is empty.

119. #### def tails: Iterator[Iterable[A]]

     Iterates over the tails of this iterable collection.

     Iterates over the tails of this iterable collection. The first value will be this iterable collection and the final one will be an empty iterable collection, with the intervening values the results of successive applications of `tail`.

     returns

       an iterator over all the tails of this iterable collection

     Definition Classes
       TraversableLike
     Example:

     1. `List(1,2,3).tails = Iterator(List(1,2,3), List(2,3), List(3), Nil)`

120. #### def take(n: Int): Iterable[A]

     Selects first n elements.

     Selects first n elements.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       Tt number of elements to take from this iterable collection.

     returns

       a iterable collection consisting only of the first `n` elements of this iterable collection, or else the whole iterable collection, if it has less than `n` elements.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

121. #### def takeRight(n: Int): Iterable[A]

     Selects last n elements.

     Selects last n elements.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the number of elements to take

     returns

       a iterable collection consisting only of the last `n` elements of this iterable collection, or else the whole iterable collection, if it has less than `n` elements.

     Definition Classes
       IterableLike

122. #### def takeWhile(p: (A) ⇒ Boolean): Iterable[A]

     Takes longest prefix of elements that satisfy a predicate.

     Takes longest prefix of elements that satisfy a predicate.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     p

       The predicate used to test elements.

     returns

       the longest prefix of this iterable collection whose elements all satisfy the predicate `p`.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

123. #### def thisCollection: Iterable[A]

     The underlying collection seen as an instance of `Iterable`.

     The underlying collection seen as an instance of `Iterable`. By default this is implemented as the current collection object itself, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       IterableLike → TraversableLike

124. #### abstract def toArray: Array[A]

     [use case] Converts this iterable collection to an array.

     [use case]

     Converts this iterable collection to an array.

     Note: will not terminate for infinite-sized collections.

     returns

       an array containing all elements of this iterable collection.

     Definition Classes
       GenTraversableOnce

125. #### def toArray[B >: A](implicit arg0: ClassManifest[B]): Array[B]

     Converts this iterable collection to an array.

     Converts this iterable collection to an array.

     Note: will not terminate for infinite-sized collections.

     B

       the type of the elements of the array. A `ClassManifest` for this type must be available.

     returns

       an array containing all elements of this iterable collection.

     Definition Classes
       TraversableOnce → GenTraversableOnce

126. #### def toBuffer[B >: A]: Buffer[B]

     Converts this iterable collection to a mutable buffer.

     Converts this iterable collection to a mutable buffer.

     Note: will not terminate for infinite-sized collections.

     returns

       a buffer containing all elements of this iterable collection.

     Definition Classes
       TraversableOnce → GenTraversableOnce

127. #### def toCollection(repr: Iterable[A]): Iterable[A]

     A conversion from collections of type `Repr` to `Iterable` objects.

     A conversion from collections of type `Repr` to `Iterable` objects. By default this is implemented as just a cast, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       IterableLike → TraversableLike

128. #### def toIndexedSeq[B >: A]: IndexedSeq[B]

     Converts this iterable collection to an indexed sequence.

     Converts this iterable collection to an indexed sequence.

     Note: will not terminate for infinite-sized collections.

     returns

       an indexed sequence containing all elements of this iterable collection.

     Definition Classes
       TraversableOnce → GenTraversableOnce

129. #### def toIterable: Iterable[A]

     Converts this iterable collection to an iterable collection.

     Converts this iterable collection to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     Note: will not terminate for infinite-sized collections.

     returns

       an `Iterable` containing all elements of this iterable collection.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce

130. #### def toIterator: Iterator[A]

     Returns an Iterator over the elements in this iterable collection.

     Returns an Iterator over the elements in this iterable collection. Will return the same Iterator if this instance is already an Iterator.

     Note: will not terminate for infinite-sized collections.

     returns

       an Iterator containing all elements of this iterable collection.

     Definition Classes
       TraversableLike → GenTraversableOnce

131. #### def toList: List[A]

     Converts this iterable collection to a list.

     Converts this iterable collection to a list.

     Note: will not terminate for infinite-sized collections.

     returns

       a list containing all elements of this iterable collection.

     Definition Classes
       TraversableOnce → GenTraversableOnce

132. #### abstract def toMap[T, U]: Map[T, U]

     [use case] Converts this iterable collection to a map.

     [use case]

     Converts this iterable collection to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     Note: will not terminate for infinite-sized collections.

     returns

       a map containing all elements of this iterable collection.

     Definition Classes
       GenTraversableOnce

133. #### def toMap[T, U](implicit ev: <:<[A, (T, U)]): Map[T, U]

     Converts this iterable collection to a map.

     Converts this iterable collection to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     Note: will not terminate for infinite-sized collections.

     returns

       a map containing all elements of this iterable collection.

     Definition Classes
       TraversableOnce → GenTraversableOnce

134. #### def toSeq: Seq[A]

     Converts this iterable collection to a sequence.

     Converts this iterable collection to a sequence. As with `toIterable`, it's lazy in this default implementation, as this `TraversableOnce` may be lazy and unevaluated.

     Note: will not terminate for infinite-sized collections.

     returns

       a sequence containing all elements of this iterable collection.

     Definition Classes
       TraversableOnce → GenTraversableOnce

135. #### def toSet[B >: A]: Set[B]

     Converts this iterable collection to a set.

     Converts this iterable collection to a set.

     Note: will not terminate for infinite-sized collections.

     returns

       a set containing all elements of this iterable collection.

     Definition Classes
       TraversableOnce → GenTraversableOnce

136. #### def toStream: Stream[A]

     Converts this iterable collection to a stream.

     Converts this iterable collection to a stream.

     Note: will not terminate for infinite-sized collections.

     returns

       a stream containing all elements of this iterable collection.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce

137. #### def toString(): String

     Converts this iterable collection to a string.

     Converts this iterable collection to a string.

     returns

       a string representation of this collection. By default this string consists of the `stringPrefix` of this iterable collection, followed by all elements separated by commas and enclosed in parentheses.

     Definition Classes
       TraversableLike → AnyRef → Any

138. #### def toTraversable: Traversable[A]

     Converts this iterable collection to an unspecified Traversable.

     Converts this iterable collection to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     Note: will not terminate for infinite-sized collections.

     returns

       a Traversable containing all elements of this iterable collection.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce

139. #### def transpose[B](implicit asTraversable: (A) ⇒ GenTraversableOnce[B]): Iterable[Iterable[B]]

     Transposes this iterable collection of traversable collections into a iterable collection of iterable collections.

     Transposes this iterable collection of traversable collections into a iterable collection of iterable collections.

     B

       the type of the elements of each traversable collection.

     asTraversable

       an implicit conversion which asserts that the element type of this iterable collection is a `Traversable`.

     returns

       a two-dimensional iterable collection of iterable collections which has as nth row the nth column of this iterable collection.

     Definition Classes
       GenericTraversableTemplate
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

     Exceptions thrown
       `IllegalArgumentException`

       if all collections in this iterable collection are not of the same size.

140. #### val underlying: Iterable[A]

141. #### def unzip[A1, A2](implicit asPair: (A) ⇒ (A1, A2)): (Iterable[A1], Iterable[A2])

     Converts this iterable collection of pairs into two collections of the first and second half of each pair.

     Converts this iterable collection of pairs into two collections of the first and second half of each pair.

     asPair

       an implicit conversion which asserts that the element type of this iterable collection is a pair.

     returns

       a pair iterable collections, containing the first, respectively second half of each element pair of this iterable collection.

     Definition Classes
       GenericTraversableTemplate

142. #### def unzip3[A1, A2, A3](implicit asTriple: (A) ⇒ (A1, A2, A3)): (Iterable[A1], Iterable[A2], Iterable[A3])

     Converts this iterable collection of triples into three collections of the first, second, and third element of each triple.

     Converts this iterable collection of triples into three collections of the first, second, and third element of each triple.

     asTriple

       an implicit conversion which asserts that the element type of this iterable collection is a triple.

     returns

       a triple iterable collections, containing the first, second, respectively third member of each element triple of this iterable collection.

     Definition Classes
       GenericTraversableTemplate

143. #### def view(from: Int, until: Int): IterableView[A, Iterable[A]]

     Creates a non-strict view of a slice of this iterable collection.

     Creates a non-strict view of a slice of this iterable collection.

     Note: the difference between `view` and `slice` is that `view` produces a view of the current iterable collection, whereas `slice` produces a new iterable collection.

     Note: `view(from, to)` is equivalent to `view.slice(from, to)`

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     from

       the index of the first element of the view

     until

       the index of the element following the view

     returns

       a non-strict view of a slice of this iterable collection, starting at index `from` and extending up to (but not including) index `until`.

     Definition Classes
       IterableLike → TraversableLike

144. #### def view: IterableView[A, Iterable[A]]

     Creates a non-strict view of this iterable collection.

     Creates a non-strict view of this iterable collection.

     returns

       a non-strict view of this iterable collection.

     Definition Classes
       IterableLike → TraversableLike

145. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

146. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

147. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

148. #### def withFilter(p: (A) ⇒ Boolean): FilterMonadic[A, Iterable[A]]

     Creates a non-strict filter of this iterable collection.

     Creates a non-strict filter of this iterable collection.

     Note: the difference between `c filter p` and `c withFilter p` is that the former creates a new collection, whereas the latter only restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     p

       the predicate used to test elements.

     returns

       an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this iterable collection which satisfy the predicate `p`.

     Definition Classes
       TraversableLike → FilterMonadic

149. #### abstract def zip[B](that: GenIterable[B]): Iterable[(A, B)]

     [use case] Returns a iterable collection formed from this iterable collection and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a iterable collection formed from this iterable collection and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this iterable collection and `that`. The length of the returned collection is the minimum of the lengths of this iterable collection and `that`.

     Definition Classes
       GenIterableLike

150. #### def zip[A1 >: A, B, That](that: GenIterable[B])(implicit bf: CanBuildFrom[Iterable[A], (A1, B), That]): That

     Returns a iterable collection formed from this iterable collection and another iterable collection by combining corresponding elements in pairs.

     Returns a iterable collection formed from this iterable collection and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     A1

       the type of the first half of the returned pairs (this is always a supertype of the collection's element type `A`).

     B

       the type of the second half of the returned pairs

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, B)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, B), That]`. is found.

     that

       The iterable providing the second half of each result pair

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `(A1, B)`.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this iterable collection and `that`. The length of the returned collection is the minimum of the lengths of this iterable collection and `that`.

     Definition Classes
       IterableLike → GenIterableLike

151. #### abstract def zipAll[B](that: Iterable[B], thisElem: A, thatElem: B): Iterable[(A, B)]

     [use case] Returns a iterable collection formed from this iterable collection and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a iterable collection formed from this iterable collection and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this iterable collection is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this iterable collection.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this iterable collection and `that`. The length of the returned collection is the maximum of the lengths of this iterable collection and `that`. If this iterable collection is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this iterable collection, `thatElem` values are used to pad the result.

     Definition Classes
       GenIterableLike

152. #### def zipAll[B, A1 >: A, That](that: GenIterable[B], thisElem: A1, thatElem: B)(implicit bf: CanBuildFrom[Iterable[A], (A1, B), That]): That

     Returns a iterable collection formed from this iterable collection and another iterable collection by combining corresponding elements in pairs.

     Returns a iterable collection formed from this iterable collection and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this iterable collection is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this iterable collection.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this iterable collection and `that`. The length of the returned collection is the maximum of the lengths of this iterable collection and `that`. If this iterable collection is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this iterable collection, `thatElem` values are used to pad the result.

     Definition Classes
       IterableLike → GenIterableLike

153. #### abstract def zipWithIndex: Iterable[(A, Int)]

     [use case] Zips this iterable collection with its indices.

     [use case]

     Zips this iterable collection with its indices.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this iterable collection paired with their index. Indices start at `0`.

     Definition Classes
       GenIterableLike

154. #### def zipWithIndex[A1 >: A, That](implicit bf: CanBuildFrom[Iterable[A], (A1, Int), That]): That

     Zips this iterable collection with its indices.

     Zips this iterable collection with its indices.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     A1

       the type of the first half of the returned pairs (this is always a supertype of the collection's element type `A`).

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, Int)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, Int), That]`. is found.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this iterable collection paired with their index. Indices start at `0`.

     Definition Classes
       IterableLike → GenIterableLike

### Deprecated Value Members

1. #### def elements: Iterator[A]

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `iterator' instead`

2. #### def first: A

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `head' instead`

3. #### def firstOption: Option[A]

   `None` if iterable is empty.

   `None` if iterable is empty.

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `headOption' instead`

4. #### def productElements: Iterator[Any]

   Definition Classes
     Product
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use productIterator instead

5. #### def projection: IterableView[A, Iterable[A]]

   returns a projection that can be used to call non-strict `filter`, `map`, and `flatMap` methods that build projections of the collection.

   returns a projection that can be used to call non-strict `filter`, `map`, and `flatMap` methods that build projections of the collection.

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `view' instead`

### Inherited from Serializable

### Inherited from Product

### Inherited from Iterable[A]

### Inherited from IterableLike[A, Iterable[A]]

### Inherited from Equals

### Inherited from GenIterable[A]

### Inherited from GenIterableLike[A, Iterable[A]]

### Inherited from Traversable[A]

### Inherited from GenTraversable[A]

### Inherited from GenericTraversableTemplate[A, Iterable]

### Inherited from TraversableLike[A, Iterable[A]]

### Inherited from GenTraversableLike[A, Iterable[A]]

### Inherited from Parallelizable[A, ParIterable[A]]

### Inherited from TraversableOnce[A]

### Inherited from GenTraversableOnce[A]

### Inherited from FilterMonadic[A, Iterable[A]]

### Inherited from HasNewBuilder[A, Iterable[A]]

### Inherited from AnyRef

### Inherited from Any